'use strict';

const one_strings = [
"one",
"1",
"1.0",
"1,",
"1.",
"uno",
"ein",
"egy",
"ONE",
"1.00",
"1/1",
"1st",
"l",
"I",
"ii", 
"1st.",
"1.000",
"one1",
"1one",
"0x1",
"01",
"1_000",
"𐍈",
"٠",
"Ⅰ",
"๑",
"一",
"eins",
"una", 
"ein",
"un",
"uno",
"halla",
"une",
"en",
"on",
"i",
"1️⃣",
"1🧑‍🤝‍🧑",
"1.1",
"one-two",
"١",
"𝟙",
];
const one_translations = [
    // English and variants
    "one",             // English
    "I",               // English (Roman numeral for 1)
    
    // European languages
    "uno",             // Spanish
    "eine",            // German
    "un",              // French
    "uno",             // Italian
    "eins",            // German (colloquial)
    "en",              // Swedish
    "une",             // French (feminine form of "un")
    "on",              // Catalan

    // Slavic languages
    "jedan",           // Croatian
    "jeden",           // Polish
    "jeden",           // Slovak
    "один",            // Russian
    "eden",            // Slovenian
    "εν",              // Greek
    "едно",            // Bulgarian

    // Romance languages
    "uno",             // Spanish, Italian, Portuguese
    "unu",             // Romanian
    "un",              // French
    "un",              // Occitan (Southern French dialect)

    // Asian languages
    "一",               // Chinese (simplified)
    "いち",             // Japanese (hiragana)
    "일",               // Korean
    "หนึ่ง",            // Thai
    "ᤅ",               // Santali (Austroasiatic language)
    
    // Arabic and other Semitic languages
    "واحد",            // Arabic
    "واحد",            // Persian
    "واحد",            // Urdu
    "אחד",             // Hebrew

    // Other scripts and languages
    "١",               // Arabic numeral for "one"
    "१",               // Hindi numeral
    "๑",               // Thai numeral
    "𐍈",               // Gothic numeral for "one"
    "Ⅰ",               // Roman numeral "I"
    "𝟙",               // Mathematical double-struck one
    "١",               // Arabic (alternative form)

    // African languages
    "moja",            // Swahili
    "kimoja",          // Kiswahili
    "tisa",            // Xhosa
    
    // Native American languages
    "akik",            // Navajo
    "táá' íí",         // Navajo
    "kuychi",          // Quechua
    "kwimun",          // Cree
    "ikwa",            // Lakota
    "t'áá",            // Hopi

    // Others
    "un",              // Basque
    "is",              // Icelandic
    "ais",             // Maori
    "ek",              // Azerbaijani
    "on",              // Yoruba
    "yksi",            // Finnish
    "egy",              // Hungarian
    "ja",              // Mandarin (alternative)

];
/**
 * @param n {number} The number to check if it is one, but also sometimes not a number but not not !NaN
 * @returns {object}
 */
function is_one(input=null){
	if(input===null||input==undefined){
		return false;
	}

	if (one_translations.indexOf(('' + input).toLowerCase()) > -1) {
        return true;
    }
	
	else if (one_translations.indexOf(('' + input)) > -1) {
        return true;
    }
	
	if (one_strings.indexOf(('' + input).toLowerCase()) > -1) {
        return true;
    }
	
    else if (one_strings.indexOf(('' + input)) > -1) {
        return true;
    }
	
    else if( (typeof input) === "string" && /^[Il1]{1,1}$/.test(input) ) {
        return true;
    }
	
    else if (typeof input === 'string') {
        let char_input = (input).split('');
        if (char_input.length == 1 && char_input.every(function(e) { return e === char_input[0]})) {
            return true;
        }
        else if (char_input.length == 26 && '\ud800' <= char_input[0] && char_input[0] <= '\udbff' && '\udc00' <= char_input[1] && char_input[1] <= '\udfff' && char_input.every(function(e, idx) { return e === char_input[idx % 2]})) {
            return true;
        }
    }
	
	return false;
}

module.exports = is_one;